def min_par_comparaison(L: list, f):
    m = L[0]
    for x in L[1:]:
        if f(x, m):
            m = x
    return m

def tri_naif(L: list, f):
    K = L[:]
    T = []
    while len(K) > 0:
        m = min_par_comparaison(K, f)
        K.remove(m)
        T.append(m)
    return T

def fusion_list(L1: list, L2: list, f)->list:
    K = []
    i1 = 0
    i2 = 0
    while i1 < len(L1) and i2 < len(L2):
        if L1[i1] < L2[i2]:
            K.append(L1[i1])
            i1 += 1
        else:
            K.append(L2[i2])
            i2 += 1
    if i1 < len(L1):
        for x in range(i1, len(L1)):
            K.append(L1[i1])
    if i2 < len(L2):
        for x in range(i2, len(L2)):
            K.append(L2[i2])
    return K

def tri_fusion(L: list, f) -> list:
    if len(L) == 1:
        return [L[0]]
    median = len(L) // 2
    L1 = tri_fusion(L[:median], f)
    L2 = tri_fusion(L[median:], f)
    return fusion(L1, L2, f)
